
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGH.  
//
// Authors:
//	jhrg,jimg	James Gallagher (jgallagher@gso.uri.edu)

// $Log: name_map.cc,v $
// Revision 1.5.10.1  1999/06/01 15:29:26  jimg
// Changed the librx code to Regex.
// Removed, for the time being, the function munge. I'm not sure this is ever
// actually used and it definitely not working (was crashing writeval at least
// on Linux (RH 5.2).
//
// Revision 1.5  1999/03/24 06:23:43  brent
// convert String.h to std lib <string>, convert to packages regex -- B^2
//
// Revision 1.4  1997/02/06 20:44:51  jimg
// Fixed log messages
//
// Revision 1.3  1997/01/10 06:50:30  jimg
// Added to lookup mfunc the ability to map non-alphanmerics to underscore.
//
// Revision 1.2  1996/11/23 05:17:39  jimg
// Added name_map() because g++ wants it.
//
// Revision 1.1  1996/11/22 23:52:01  jimg
// Created.
//

#ifdef __GNUG__
#pragma implementation
#endif

#include "config_dap.h"

static char rcsid[] not_used = {"$Id: name_map.cc,v 1.5.10.1 1999/06/01 15:29:26 jimg Exp $"};

#include <string>

#include "Pix.h"
#include "SLList.h"
#include "Regex.h"

#include "name_map.h"

#if 0
extern "C" {
#include "rx.h"
}
#endif

name_map::name_map(char *raw_equiv) 
{
    _names.append(name_equiv(raw_equiv));
}

name_map::name_map()
{
}

void 
name_map::add(char *raw_equiv) 
{
    name_equiv equiv(raw_equiv);
    _names.append(equiv);
}

static string
munge(string name)
{
#if 0
     static Regex hex("%[0-9][0-9A-Fa-f]", 1);
     while (hex.match(name.c_str(), 0)) {
	 int start, len;
	 hex.match_info(start, len, 0);
	 name[start] = '_';	// Rewrite the % to _
	 int j;			// now shuffle remaining chars left two places
	 for (int i = start + 1, j = i + 2; j < name.length(); ++i, ++j)
	     name[i] = name[j];
     }

     static Regex bad("[^A-z0-9_]", 1);
     while (bad.match(name.c_str(), 0)) {
	 int start, len;
	 bad.match_info(start, len, 0);
	 name[start] = '_';
     }
 
#endif
     return name;
}

string
name_map::lookup(string name, const bool canonical_names = false) 
{
    for (Pix p = _names.first(); p; _names.next(p))
	if (name == _names(p).from) {
	    if (!canonical_names) {
		return _names(p).to;
	    }
	    else {
		string tmp_name = _names(p).to;
		static Regex rc("[A-Za-z_][A-Za-z0-9_]*", 1);

		if (rc.match(tmp_name.c_str(), 0))
		    return tmp_name;
		else
		    return munge(tmp_name);
	    }
	}

    if (!canonical_names)
	return name;
    else
	return munge(name);
}

void 
name_map::delete_all() 
{
    _names.clear();
}

